io.vertx.rxjava.core.http

## Class HttpClientRequest

- java.lang.Object
- - io.vertx.rxjava.core.http.HttpClientRequest

- All Implemented Interfaces:
    StreamBase, WriteStream<Buffer>

      public class HttpClientRequest
      extends Object
      implements WriteStream<Buffer>

  Represents a client-side HTTP request.

  Instances are created by an `HttpClient` instance, via one of the methods corresponding to the specific HTTP methods, or the generic request methods. On creation the request will not have been written to the wire.

  Once a request has been obtained, headers can be set on it, and data can be written to its body if required. Once you are ready to send the request, one of the `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` methods should be called.

  Nothing is actually sent until the request has been internally assigned an HTTP connection.

  The `HttpClient` instance will return an instance of this class immediately, even if there are no HTTP connections available in the pool. Any requests sent before a connection is assigned will be queued internally and actually sent when an HTTP connection becomes available from the pool.

  The headers of the request are queued for writing either when the `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method is called, or, when the first part of the body is written, whichever occurs first.

  This class supports both chunked and non-chunked HTTP.

  It implements `WriteStream` so it can be used with `Pipe` to pipe data with flow control.

  An example of using this class is as follows:

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static io.vertx.lang.rx.TypeArg<HttpClientRequest>` | `__TYPE_ARG`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HttpClientRequest(HttpClientRequest delegate)`
    `HttpClientRequest(Object delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `absoluteURI()`
    `void` | `connect()` Create an HTTP tunnel to the server.
    `void` | `connect(Handler<AsyncResult<HttpClientResponse>> handler)` Create an HTTP tunnel to the server.
    `HttpConnection` | `connection()`
    `HttpClientRequest` | `continueHandler(Handler<Void> handler)` If you send an HTTP request with the header `Expect` set to the value `100-continue` and the server responds with an interim HTTP response with a status code of `100` and a continue handler has been set using this method, then the `handler` will be called.
    `HttpClientRequest` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `end(Buffer chunk)` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `end(Buffer chunk, Handler<AsyncResult<Void>> handler)` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `end(Handler<AsyncResult<Void>> handler)` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `end(String chunk)` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `end(String chunk, Handler<AsyncResult<Void>> handler)` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `end(String chunk, String enc)` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `end(String chunk, String enc, Handler<AsyncResult<Void>> handler)` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `boolean` | `equals(Object o)`
    `HttpClientRequest` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the write stream.
    `HttpClientRequest` | `getDelegate()`
    `String` | `getHost()`
    `HttpMethod` | `getMethod()` The HTTP method for the request.
    `int` | `getPort()`
    `StreamPriority` | `getStreamPriority()`
    `String` | `getURI()`
    `int` | `hashCode()`
    `MultiMap` | `headers()`
    `boolean` | `isChunked()`
    `static HttpClientRequest` | `newInstance(HttpClientRequest arg)`
    `String` | `path()`
    `HttpClientRequest` | `pushHandler(Handler<HttpClientRequest> handler)` Set a push handler for this request. The handler is called when the client receives a push promise from the server.
    `HttpClientRequest` | `putHeader(CharSequence name, CharSequence value)` Like `putHeader(java.lang.String, java.lang.String)` but using CharSequence
    `HttpClientRequest` | `putHeader(CharSequence name, Iterable<CharSequence> values)` Like `putHeader(java.lang.String, java.lang.String)` but using CharSequence
    `HttpClientRequest` | `putHeader(String name, Iterable<String> values)` Put an HTTP header with multiple values
    `HttpClientRequest` | `putHeader(String name, String value)` Put an HTTP header
    `String` | `query()`
    `boolean` | `reset()` Reset this stream with the error code `0`.
    `boolean` | `reset(long code)` Reset this request: for HTTP/2, this performs send an HTTP/2 reset frame with the specified error `code` for HTTP/1.x, this closes the connection when the current request is inflight When the request has not yet been sent, the request will be aborted and false is returned as indicator.
    `boolean` | `reset(long code, Throwable cause)` Reset this request: for HTTP/2, send an HTTP/2 reset frame with the specified error `code` for HTTP/1.x, close the connection when the current request is inflight When the request has not yet been sent, the request will be aborted and `false` is returned as indicator.
    `HttpClientRequest` | `response()` Set a callback for the associated `HttpClientResponse`.
    `HttpClientRequest` | `response(Handler<AsyncResult<HttpClientResponse>> handler)` Set a callback for the associated `HttpClientResponse`.
    `Single<HttpClientResponse>` | `rxConnect()` Create an HTTP tunnel to the server.
    `Single<Void>` | `rxEnd()` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Single<Void>` | `rxEnd(Buffer chunk)` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Single<Void>` | `rxEnd(String chunk)` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Single<Void>` | `rxEnd(String chunk, String enc)` Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Single<HttpClientResponse>` | `rxResponse()` Set a callback for the associated `HttpClientResponse`.
    `Single<HttpClientResponse>` | `rxSend()` Send the request with an empty body.
    `Single<HttpClientResponse>` | `rxSend(Buffer body)` Send the request with a buffer `body`.
    `Single<HttpClientResponse>` | `rxSend(Observable<Buffer> body)` Send the request with a stream `body`.
    `Single<HttpClientResponse>` | `rxSend(ReadStream<Buffer> body)` Send the request with a stream `body`.
    `Single<HttpClientResponse>` | `rxSend(String body)` Send the request with a string `body`.
    `Single<Void>` | `rxSendHead()` Like `sendHead(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an handler after headers have been sent.
    `Single<Void>` | `rxWrite(Buffer data)` Same as but with an `handler` called when the operation completes
    `Single<Void>` | `rxWrite(String chunk)` Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Single<Void>` | `rxWrite(String chunk, String enc)` Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `send()` Send the request with an empty body.
    `void` | `send(Buffer body)` Send the request with a buffer `body`.
    `void` | `send(Buffer body, Handler<AsyncResult<HttpClientResponse>> handler)` Send the request with a buffer `body`.
    `void` | `send(Handler<AsyncResult<HttpClientResponse>> handler)` Send the request with an empty body.
    `void` | `send(Observable<Buffer> body)` Send the request with a stream `body`.
    `void` | `send(Observable<Buffer> body, Handler<AsyncResult<HttpClientResponse>> handler)` Send the request with a stream `body`.
    `void` | `send(ReadStream<Buffer> body)` Send the request with a stream `body`.
    `void` | `send(ReadStream<Buffer> body, Handler<AsyncResult<HttpClientResponse>> handler)` Send the request with a stream `body`.
    `void` | `send(String body)` Send the request with a string `body`.
    `void` | `send(String body, Handler<AsyncResult<HttpClientResponse>> handler)` Send the request with a string `body`.
    `HttpClientRequest` | `sendHead()` Like `sendHead(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an handler after headers have been sent.
    `HttpClientRequest` | `sendHead(Handler<AsyncResult<Void>> completionHandler)` Like `sendHead(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an handler after headers have been sent.
    `HttpClientRequest` | `setChunked(boolean chunked)` If chunked is true then the request will be set into HTTP chunked mode
    `HttpClientRequest` | `setFollowRedirects(boolean followRedirects)` Set the request to follow HTTP redirects up to `HttpClientOptions`.
    `HttpClientRequest` | `setHost(String host)` Set the host value of the HTTP/1.1 `host` header or HTTP/2 `authority` pseudo header
    `HttpClientRequest` | `setMaxRedirects(int maxRedirects)` Set the max number of HTTP redirects this request will follow.
    `HttpClientRequest` | `setMethod(HttpMethod method)` Set the HTTP method for this request.
    `HttpClientRequest` | `setPort(int port)` Set the port value of the HTTP/1.1 `host` header or HTTP/2 `authority` pseudo header
    `HttpClientRequest` | `setStreamPriority(StreamPriority streamPriority)` Sets the priority of the associated stream.
    `HttpClientRequest` | `setTimeout(long timeoutMs)` Set's the amount of time after which if the request does not return any data within the timeout period an `TimeoutException` will be passed to the exception handler (if provided) and the request will be closed.
    `HttpClientRequest` | `setURI(String uri)` Set the request uri.
    `HttpClientRequest` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `int` | `streamId()`
    `String` | `toString()`
    `io.vertx.rx.java.WriteStreamSubscriber<Buffer>` | `toSubscriber()`
    `HttpVersion` | `version()`
    `void` | `write(Buffer data)` Same as but with an `handler` called when the operation completes
    `void` | `write(Buffer data, Handler<AsyncResult<Void>> handler)` Same as but with an `handler` called when the operation completes
    `void` | `write(String chunk)` Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `write(String chunk, Handler<AsyncResult<Void>> handler)` Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `write(String chunk, String enc)` Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `write(String chunk, String enc, Handler<AsyncResult<Void>> handler)` Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `HttpClientRequest` | `writeCustomFrame(HttpFrame frame)` Like `writeCustomFrame(int, int, io.vertx.rxjava.core.buffer.Buffer)` but with an `HttpFrame`.
    `HttpClientRequest` | `writeCustomFrame(int type, int flags, Buffer payload)` Write an HTTP/2 frame to the request, allowing to extend the HTTP/2 protocol.
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.WriteStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.StreamBase

      `newInstance`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<HttpClientRequest> __TYPE_ARG

  - ### Constructor Detail

    - #### HttpClientRequest

          public HttpClientRequest(HttpClientRequest delegate)

    - #### HttpClientRequest

          public HttpClientRequest(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public HttpClientRequest getDelegate()

      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toSubscriber

          public io.vertx.rx.java.WriteStreamSubscriber<Buffer> toSubscriber()

    - #### write

          public void write(Buffer data,
                            Handler<AsyncResult<Void>> handler)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -
        `handler` -

    - #### write

          public void write(Buffer data)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -

    - #### rxWrite

          public Single<Void> rxWrite(Buffer data)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `rxWrite` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -
      Returns:

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        `true` if write queue is full

    - #### exceptionHandler

          public HttpClientRequest exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `WriteStream`
      Set an exception handler on the write stream.
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          public HttpClientRequest setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public HttpClientRequest drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### setHost

          public HttpClientRequest setHost(String host)

      Set the host value of the HTTP/1.1 `host` header or HTTP/2 `authority` pseudo header

      The initial value is the same than the server socket address host.

      Keep in mind that changing this value won't change the actual server socket address for this request.

      Parameters:
        `host` - the host part of the HTTP/1.1 `host` header or HTTP/2 `authority` pseudo header
      Returns:
        a reference to this, so the API can be used fluently

    - #### getHost

          public String getHost()

      Returns:
        the host value of the HTTP/1.1 `host` header or HTTP/2 `authority` pseudo header

    - #### setPort

          public HttpClientRequest setPort(int port)

      Set the port value of the HTTP/1.1 `host` header or HTTP/2 `authority` pseudo header

      Keep in mind that this won't change the actual server socket address for this request.

      The initial value is the same than the server socket address port.

      Parameters:
        `port` - the port part of the HTTP/1.1 `host` header or HTTP/2 `authority` pseudo header
      Returns:
        a reference to this, so the API can be used fluently

    - #### getPort

          public int getPort()

      Returns:
        the port value of the HTTP/1.1 `host` header or HTTP/2 `authority` pseudo header

    - #### setFollowRedirects

          public HttpClientRequest setFollowRedirects(boolean followRedirects)

      Set the request to follow HTTP redirects up to `HttpClientOptions`.
      Parameters:
        `followRedirects` - `true` to follow HTTP redirects
      Returns:
        a reference to this, so the API can be used fluently

    - #### setMaxRedirects

          public HttpClientRequest setMaxRedirects(int maxRedirects)

      Set the max number of HTTP redirects this request will follow. The default is `0` which means no redirects.
      Parameters:
        `maxRedirects` - the number of HTTP redirect to follow
      Returns:
        a reference to this, so the API can be used fluently

    - #### setChunked

          public HttpClientRequest setChunked(boolean chunked)

      If chunked is true then the request will be set into HTTP chunked mode
      Parameters:
        `chunked` - true if chunked encoding
      Returns:
        a reference to this, so the API can be used fluently

    - #### isChunked

          public boolean isChunked()

      Returns:
        Is the request chunked?

    - #### getMethod

          public HttpMethod getMethod()

      The HTTP method for the request.
      Returns:

    - #### setMethod

          public HttpClientRequest setMethod(HttpMethod method)

      Set the HTTP method for this request.
      Parameters:
        `method` - the HTTP method
      Returns:
        a reference to this, so the API can be used fluently

    - #### absoluteURI

          public String absoluteURI()

      Returns:
        the absolute URI corresponding to the the HTTP request

    - #### getURI

          public String getURI()

      Returns:
        The URI of the request.

    - #### setURI

          public HttpClientRequest setURI(String uri)

      Set the request uri.
      Parameters:
        `uri` - the request uri
      Returns:
        a reference to this, so the API can be used fluently

    - #### path

          public String path()

      Returns:
        The path part of the uri. For example /somepath/somemorepath/someresource.foo

    - #### query

          public String query()

      Returns:
        the query part of the uri. For example someparam=32&someotherparam=x

    - #### headers

          public MultiMap headers()

      Returns:
        The HTTP headers

    - #### putHeader

          public HttpClientRequest putHeader(String name,
                                             String value)

      Put an HTTP header
      Parameters:
        `name` - The header name
        `value` - The header value
      Returns:
        a reference to this, so the API can be used fluently

    - #### version

          public HttpVersion version()

      Returns:
        the HTTP version for this request

    - #### write

          public void write(String chunk,
                            Handler<AsyncResult<Void>> handler)

      Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -
        `handler` -

    - #### write

          public void write(String chunk)

      Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -

    - #### rxWrite

          public Single<Void> rxWrite(String chunk)

      Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -
      Returns:

    - #### write

          public void write(String chunk,
                            String enc,
                            Handler<AsyncResult<Void>> handler)

      Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -
        `enc` -
        `handler` -

    - #### write

          public void write(String chunk,
                            String enc)

      Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -
        `enc` -

    - #### rxWrite

          public Single<Void> rxWrite(String chunk,
                                      String enc)

      Same as `write(io.vertx.rxjava.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -
        `enc` -
      Returns:

    - #### continueHandler

          public HttpClientRequest continueHandler(Handler<Void> handler)

      If you send an HTTP request with the header `Expect` set to the value `100-continue` and the server responds with an interim HTTP response with a status code of `100` and a continue handler has been set using this method, then the `handler` will be called.

      You can then continue to write data to the request body and later end it. This is normally used in conjunction with the `sendHead(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method to force the request header to be written before the request has ended.

      Parameters:
        `handler` -
      Returns:
        a reference to this, so the API can be used fluently

    - #### sendHead

          public HttpClientRequest sendHead(Handler<AsyncResult<Void>> completionHandler)

      Like `sendHead(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an handler after headers have been sent. The handler will be called with the `HttpVersion` if it can be determined or null otherwise.

      Parameters:
        `completionHandler` -
      Returns:

    - #### sendHead

          public HttpClientRequest sendHead()

      Like `sendHead(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an handler after headers have been sent. The handler will be called with the `HttpVersion` if it can be determined or null otherwise.

      Returns:

    - #### rxSendHead

          public Single<Void> rxSendHead()

      Like `sendHead(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an handler after headers have been sent. The handler will be called with the `HttpVersion` if it can be determined or null otherwise.

      Returns:

    - #### connect

          public void connect(Handler<AsyncResult<HttpClientResponse>> handler)

      Create an HTTP tunnel to the server.

      Send an HTTP request to the server, then configures the transport to exchange raw buffers when the server replies with an appropriate response:

      - `200` for HTTP `CONNECT` method
      - `101` for HTTP/1.1 `GET` with `Upgrade` `connection` header

      The `handler` is called after response headers are received.

      Use `HttpClientResponse.netSocket()` to get a for the interacting more conveniently with the server.

      HTTP/1.1 pipe-lined requests are not supported.

      Parameters:
        `handler` - the response completion handler

    - #### connect

          public void connect()

      Create an HTTP tunnel to the server.

      Send an HTTP request to the server, then configures the transport to exchange raw buffers when the server replies with an appropriate response:

      - `200` for HTTP `CONNECT` method
      - `101` for HTTP/1.1 `GET` with `Upgrade` `connection` header

      The `handler` is called after response headers are received.

      Use `HttpClientResponse.netSocket()` to get a for the interacting more conveniently with the server.

      HTTP/1.1 pipe-lined requests are not supported.

    - #### rxConnect

          public Single<HttpClientResponse> rxConnect()

      Create an HTTP tunnel to the server.

      Send an HTTP request to the server, then configures the transport to exchange raw buffers when the server replies with an appropriate response:

      - `200` for HTTP `CONNECT` method
      - `101` for HTTP/1.1 `GET` with `Upgrade` `connection` header

      The `handler` is called after response headers are received.

      Use `HttpClientResponse.netSocket()` to get a for the interacting more conveniently with the server.

      HTTP/1.1 pipe-lined requests are not supported.

      Returns:

    - #### response

          public HttpClientRequest response(Handler<AsyncResult<HttpClientResponse>> handler)

      Set a callback for the associated `HttpClientResponse`.

      This method does not modify the current request being sent.

      Parameters:
        `handler` - the completion handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### response

          public HttpClientRequest response()

      Set a callback for the associated `HttpClientResponse`.

      This method does not modify the current request being sent.

      Returns:
        a reference to this, so the API can be used fluently

    - #### rxResponse

          public Single<HttpClientResponse> rxResponse()

      Set a callback for the associated `HttpClientResponse`.

      This method does not modify the current request being sent.

      Returns:
        a reference to this, so the API can be used fluently

    - #### send

          public void send(Handler<AsyncResult<HttpClientResponse>> handler)

      Send the request with an empty body.
      Parameters:
        `handler` - the completion handler for the `HttpClientResponse`

    - #### send

          public void send()

      Send the request with an empty body.

    - #### rxSend

          public Single<HttpClientResponse> rxSend()

      Send the request with an empty body.
      Returns:

    - #### send

          public void send(String body,
                           Handler<AsyncResult<HttpClientResponse>> handler)

      Send the request with a string `body`.
      Parameters:
        `body` -
        `handler` - the completion handler for the `HttpClientResponse`

    - #### send

          public void send(String body)

      Send the request with a string `body`.
      Parameters:
        `body` -

    - #### rxSend

          public Single<HttpClientResponse> rxSend(String body)

      Send the request with a string `body`.
      Parameters:
        `body` -
      Returns:

    - #### send

          public void send(Buffer body,
                           Handler<AsyncResult<HttpClientResponse>> handler)

      Send the request with a buffer `body`.
      Parameters:
        `body` -
        `handler` - the completion handler for the `HttpClientResponse`

    - #### send

          public void send(Buffer body)

      Send the request with a buffer `body`.
      Parameters:
        `body` -

    - #### rxSend

          public Single<HttpClientResponse> rxSend(Buffer body)

      Send the request with a buffer `body`.
      Parameters:
        `body` -
      Returns:

    - #### send

          public void send(ReadStream<Buffer> body,
                           Handler<AsyncResult<HttpClientResponse>> handler)

      Send the request with a stream `body`.

      If the `HttpHeaders` is set then the request assumes this is the length of the {stream}, otherwise the request will set a chunked `HttpHeaders`.

      Parameters:
        `body` -
        `handler` - the completion handler for the `HttpClientResponse`

    - #### send

          public void send(ReadStream<Buffer> body)

      Send the request with a stream `body`.

      If the `HttpHeaders` is set then the request assumes this is the length of the {stream}, otherwise the request will set a chunked `HttpHeaders`.

      Parameters:
        `body` -

    - #### rxSend

          public Single<HttpClientResponse> rxSend(ReadStream<Buffer> body)

      Send the request with a stream `body`.

      If the `HttpHeaders` is set then the request assumes this is the length of the {stream}, otherwise the request will set a chunked `HttpHeaders`.

      Parameters:
        `body` -
      Returns:

    - #### send

          public void send(Observable<Buffer> body,
                           Handler<AsyncResult<HttpClientResponse>> handler)

      Send the request with a stream `body`.

      If the `HttpHeaders` is set then the request assumes this is the length of the {stream}, otherwise the request will set a chunked `HttpHeaders`.

      Parameters:
        `body` -
        `handler` - the completion handler for the `HttpClientResponse`

    - #### send

          public void send(Observable<Buffer> body)

      Send the request with a stream `body`.

      If the `HttpHeaders` is set then the request assumes this is the length of the {stream}, otherwise the request will set a chunked `HttpHeaders`.

      Parameters:
        `body` -

    - #### rxSend

          public Single<HttpClientResponse> rxSend(Observable<Buffer> body)

      Send the request with a stream `body`.

      If the `HttpHeaders` is set then the request assumes this is the length of the {stream}, otherwise the request will set a chunked `HttpHeaders`.

      Parameters:
        `body` -
      Returns:

    - #### end

          public void end(String chunk,
                          Handler<AsyncResult<Void>> handler)

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -
        `handler` -

    - #### end

          public void end(String chunk)

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -

    - #### rxEnd

          public Single<Void> rxEnd(String chunk)

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -
      Returns:

    - #### end

          public void end(String chunk,
                          String enc,
                          Handler<AsyncResult<Void>> handler)

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -
        `enc` -
        `handler` -

    - #### end

          public void end(String chunk,
                          String enc)

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -
        `enc` -

    - #### rxEnd

          public Single<Void> rxEnd(String chunk,
                                    String enc)

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Parameters:
        `chunk` -
        `enc` -
      Returns:

    - #### end

          public void end(Buffer chunk,
                          Handler<AsyncResult<Void>> handler)

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `chunk` -
        `handler` -

    - #### end

          public void end(Buffer chunk)

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `chunk` -

    - #### rxEnd

          public Single<Void> rxEnd(Buffer chunk)

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Parameters:
        `chunk` -
      Returns:

    - #### end

          public void end(Handler<AsyncResult<Void>> handler)

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` -

    - #### end

          public void end()

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### rxEnd

          public Single<Void> rxEnd()

      Same as `end(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Returns:

    - #### setTimeout

          public HttpClientRequest setTimeout(long timeoutMs)

      Set's the amount of time after which if the request does not return any data within the timeout period an `TimeoutException` will be passed to the exception handler (if provided) and the request will be closed.

      Calling this method more than once has the effect of canceling any existing timeout and starting the timeout from scratch.

      Parameters:
        `timeoutMs` - The quantity of time in milliseconds.
      Returns:
        a reference to this, so the API can be used fluently

    - #### pushHandler

          public HttpClientRequest pushHandler(Handler<HttpClientRequest> handler)

      Set a push handler for this request.

      The handler is called when the client receives a push promise from the server. The handler can be called multiple times, for each push promise.

      The handler is called with a read-only `HttpClientRequest`, the following methods can be called:

      - `getMethod()`
      - `getURI()`
      - `headers()`
      In addition the handler should call the `response(io.vertx.core.Handler<io.vertx.core.AsyncResult<io.vertx.rxjava.core.http.HttpClientResponse>>)` method to set an handler to process the response.

      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### reset

          public boolean reset()

      Reset this stream with the error code `0`.
      Returns:

    - #### reset

          public boolean reset(long code)

      Reset this request:

      - for HTTP/2, this performs send an HTTP/2 reset frame with the specified error `code`
      - for HTTP/1.x, this closes the connection when the current request is inflight

      When the request has not yet been sent, the request will be aborted and false is returned as indicator.

      Parameters:
        `code` - the error code
      Returns:
        `true` when reset has been performed

    - #### reset

          public boolean reset(long code,
                               Throwable cause)

      Reset this request:

      - for HTTP/2, send an HTTP/2 reset frame with the specified error `code`
      - for HTTP/1.x, close the connection when the current request is inflight

      When the request has not yet been sent, the request will be aborted and `false` is returned as indicator.

      Parameters:
        `code` - the error code
        `cause` - an optional cause that can be attached to the error code
      Returns:
        true when reset has been performed

    - #### connection

          public HttpConnection connection()

      Returns:
        the `HttpConnection` associated with this request

    - #### writeCustomFrame

          public HttpClientRequest writeCustomFrame(int type,
                                                    int flags,
                                                    Buffer payload)

      Write an HTTP/2 frame to the request, allowing to extend the HTTP/2 protocol.

      The frame is sent immediatly and is not subject to flow control.

      This method must be called after the request headers have been sent and only for the protocol HTTP/2. The `sendHead(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` should be used for this purpose.

      Parameters:
        `type` - the 8-bit frame type
        `flags` - the 8-bit frame flags
        `payload` - the frame payload
      Returns:
        a reference to this, so the API can be used fluently

    - #### streamId

          public int streamId()

      Returns:
        the id of the stream of this response, when it is not yet determined, i.e the request has not been yet sent or it is not supported HTTP/1.x

    - #### writeCustomFrame

          public HttpClientRequest writeCustomFrame(HttpFrame frame)

      Like `writeCustomFrame(int, int, io.vertx.rxjava.core.buffer.Buffer)` but with an `HttpFrame`.
      Parameters:
        `frame` - the frame to write
      Returns:

    - #### setStreamPriority

          public HttpClientRequest setStreamPriority(StreamPriority streamPriority)

      Sets the priority of the associated stream.

      This is not implemented for HTTP/1.x.
      Parameters:
        `streamPriority` - the priority of this request's stream
      Returns:

    - #### getStreamPriority

          public StreamPriority getStreamPriority()

      Returns:
        the priority of the associated HTTP/2 stream for HTTP/2 otherwise `null`

    - #### putHeader

          public HttpClientRequest putHeader(CharSequence name,
                                             CharSequence value)

      Like `putHeader(java.lang.String, java.lang.String)` but using CharSequence
      Parameters:
        `name` -
        `value` -
      Returns:

    - #### putHeader

          public HttpClientRequest putHeader(String name,
                                             Iterable<String> values)

      Put an HTTP header with multiple values
      Parameters:
        `name` - The header name
        `values` - The header values
      Returns:
        @return a reference to this, so the API can be used fluently

    - #### putHeader

          public HttpClientRequest putHeader(CharSequence name,
                                             Iterable<CharSequence> values)

      Like `putHeader(java.lang.String, java.lang.String)` but using CharSequence
      Parameters:
        `name` -
        `values` -
      Returns:

    - #### newInstance

          public static HttpClientRequest newInstance(HttpClientRequest arg)

Copyright © 2021 Eclipse. All rights reserved.